/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2020-2024. All rights reserved.
 */

#ifndef DPC_IMPL_TYPE_RIGHTLINE_H
#define DPC_IMPL_TYPE_RIGHTLINE_H

#include "impl_type_uint32.h"
#include "dpc/impl_type_array_rmegorgtlnegeometry_6.h"
#include "impl_type_uint8.h"
#include "impl_type_boolean.h"

namespace dpc {
struct RightLine {
    ::UInt32 rm_egorgtlne_id{ 0U };
    ::dpc::array_RMEgoRgtLnegeometry_6 rm_egorgtlne_geometry{};
    ::UInt8 rm_egorgtlne_color{ 0U };
    ::UInt8 rm_egorgtlne_type{ 0U };
    ::Boolean rm_egorgtlne_edoutview{ false };
    ::UInt8 rm_rgtlnesnsrsource{ 0U };

    static bool IsPlane()
    {
        return false;
    }


    using IsEnumerableTag = void;
    template<typename F>
    void enumerate(F& fun)
    {
        fun(rm_egorgtlne_id);
        fun(rm_egorgtlne_geometry);
        fun(rm_egorgtlne_color);
        fun(rm_egorgtlne_type);
        fun(rm_egorgtlne_edoutview);
        fun(rm_rgtlnesnsrsource);
    }

    template<typename F>
    void enumerate(F& fun) const
    {
        fun(rm_egorgtlne_id);
        fun(rm_egorgtlne_geometry);
        fun(rm_egorgtlne_color);
        fun(rm_egorgtlne_type);
        fun(rm_egorgtlne_edoutview);
        fun(rm_rgtlnesnsrsource);
    }

    template<typename F>
    void enumerate_internal(F& fun)
    {
        fun("rm_egorgtlne_id", rm_egorgtlne_id);
        fun("rm_egorgtlne_geometry", rm_egorgtlne_geometry);
        fun("rm_egorgtlne_color", rm_egorgtlne_color);
        fun("rm_egorgtlne_type", rm_egorgtlne_type);
        fun("rm_egorgtlne_edoutview", rm_egorgtlne_edoutview);
        fun("rm_rgtlnesnsrsource", rm_rgtlnesnsrsource);
    }

    template<typename F>
    void enumerate_internal(F& fun) const
    {
        fun("rm_egorgtlne_id", rm_egorgtlne_id);
        fun("rm_egorgtlne_geometry", rm_egorgtlne_geometry);
        fun("rm_egorgtlne_color", rm_egorgtlne_color);
        fun("rm_egorgtlne_type", rm_egorgtlne_type);
        fun("rm_egorgtlne_edoutview", rm_egorgtlne_edoutview);
        fun("rm_rgtlnesnsrsource", rm_rgtlnesnsrsource);
    }

    friend bool operator==(const ::dpc::RightLine& lhs, const ::dpc::RightLine& rhs) noexcept
    {
        return (lhs.rm_egorgtlne_id == rhs.rm_egorgtlne_id) && (lhs.rm_egorgtlne_geometry == rhs.rm_egorgtlne_geometry) && (lhs.rm_egorgtlne_color == rhs.rm_egorgtlne_color) && (lhs.rm_egorgtlne_type == rhs.rm_egorgtlne_type) && (lhs.rm_egorgtlne_edoutview == rhs.rm_egorgtlne_edoutview) && (lhs.rm_rgtlnesnsrsource == rhs.rm_rgtlnesnsrsource);
    }
};
} // namespace dpc


#endif // DPC_IMPL_TYPE_RIGHTLINE_H
